#include "edge.h"
#include "factor.h"
#include "binary_variable.h"


ostream &operator<<(ostream &os, Edge &e) {
  os << "(" << e.GetFactor()->Name() << ", " << e.GetVariable()->Name() << ">";
  return os;
}


void Edge::SetToFactor(double to_factor) { 
  CHECK_SMALL(to_factor, "Huge incoming message value");
  
  //double old_message = to_factor_;
  // Tell the factor that we're changing an incoming message
  //GetFactor()->UpdateMessage(position_in_factor_, old_message, to_factor);
  
  to_factor_ = to_factor; 
}


void Edge::Print() {
  cout << endpoints_.first->Name() << "-->" << endpoints_.second->Name() 
       << " " << ToFactor() << endl;
  cout << endpoints_.second->Name() << "-->" << endpoints_.first->Name() 
       << " " << ToVariable() << endl;
}
