// Copyright 2009 and onwards
// Author: dtarlow@cs.toronto.edu (Danny Tarlow)
// 7/25/09

#ifndef CYBORG_MESSAGE_H__
#define CYBORG_MESSAGE_H__

using namespace std;

#include "utils.h"

class Edge;

class Message {

  friend ostream &operator<<(ostream &os, Message &m);

 public:
  
  Message(Edge *edge, message_direction_t direction) {
    edge_ = edge;
    direction_ = direction;
    is_active_ = false;
  }
  
  ~Message() {}

  string Name();

  void UpdateMessage();

  void ComputeMessage();

  int PositionInVariable();

  int PositionInFactor();

  double NewValue();

  double CurrentValue();

  Edge *GetEdge() { return edge_; }

  message_direction_t Direction() { return direction_; }

  void Disable() { is_active_ = false; }
  void Enable() { is_active_ = true; }
  bool IsActive() { return is_active_; }

  int ID() { return message_id_; }
  void SetID(int id) { message_id_ = id; }

 protected:
  Edge *edge_;

  message_direction_t direction_;

  bool is_active_;

  int message_id_;

};

#endif
