// Copyright 2007 and onwards
// Author: dtarlow@cs.toronto.edu (Danny Tarlow)
// 1/10/2007
//
// Unit test for assignment class

#include <iostream>
#include "utils.h"
#include "unittest.h"
#include "counts_factor_unittest.h"
#include "best_first_search_unittest.h"
#include "heap_unittest.h"
#include "hyper_matrix_unittest.h"
#include "graph_creator_unittest.h"
#include "rbp_unittest.h"
#include "asynchronous_unittest.h"
#include "linear_distance_factor_unittest.h"
#include "segmentation_data_unittest.h"
#include "submodular_grid_factor_unittest.h"

//#include "dynamic_graph_cut_unittest.h"

//#include "bipartite_unittest.h"



int main(int argc, char **argv) {
  cout << argv[0] << " " << argc << endl;

  vector<string> test_names;
  vector<bool> test_results;

  //HyperMatrixUnitTest hyper_matrix_test;
  //test_names.push_back(hyper_matrix_test.TestName());
  //  test_results.push_back(hyper_matrix_test.RunTests());

  /*
  GraphCreatorUnitTest graph_creator_test;
  test_names.push_back(graph_creator_test.TestName());
  test_results.push_back(graph_creator_test.RunTests());


  HeapUnitTest heap_test;
  test_names.push_back(heap_test.TestName());
  test_results.push_back(heap_test.RunTests());

  AsynchronousUnitTest asynch_test;
  test_names.push_back(asynch_test.TestName());
  test_results.push_back(asynch_test.RunTests());

  LinearDistanceFactorUnitTest linear_distance_test;
  test_names.push_back(linear_distance_test.TestName());
  test_results.push_back(linear_distance_test.RunTests());

  RBPUnitTest rbp_test;
  test_names.push_back(rbp_test.TestName());
  test_results.push_back(rbp_test.RunTests());
  */

  //BipartiteUnitTest bipartite_test;
  //test_names.push_back(bipartite_test.TestName());
  //test_results.push_back(bipartite_test.RunTests());

  //DynamicGraphCutUnitTest dgc_test;
  //test_names.push_back(dgc_test.TestName());
  //test_results.push_back(dgc_test.RunTests());

  CountsFactorUnitTest counts_factor_test;
  test_names.push_back(counts_factor_test.TestName());
  test_results.push_back(counts_factor_test.RunTests());


  SubmodularGridFactorUnitTest sgf_test;
  test_names.push_back(sgf_test.TestName());
  test_results.push_back(sgf_test.RunTests());

  /*
    SegmentationDataUnitTest segmentation_data_test;
    test_names.push_back(segmentation_data_test.TestName());
    test_results.push_back(segmentation_data_test.RunTests());

    BestFirstSearchUnitTest best_first_search_test;
    test_names.push_back(best_first_search_test.TestName());
    test_results.push_back(best_first_search_test.RunTests());
  */

  // Display Results
  for (uint i = 0; i < test_names.size(); i++) {
    string result;
    if (test_results[i]) {
      result = "PASSED";
    } else {
      result = "FAILED";
    }
    cout << test_names[i] << ": " << result << endl;
  }

}
