// Copyright 2009 and onwards
// Author: dtarlow@cs.toronto.edu (Danny Tarlow)
// 7/27/09

#ifndef CYBORG_SEQUENCE_FACTOR_H__
#define CYBORG_SEQUENCE_FACTOR_H__

#include "factor.h"
#include <vector>
#include <string>


class SequenceFactor : public Factor {

 public:
  SequenceFactor(string name);
  ~SequenceFactor();
  

  void LoadIncomingMessagesFromEdges();

  void SetIncomingMessage(int var, double val);

  void ComputeOutgoingMessage(int position_in_factor);

  void ComputeAllOutgoingMessages();

  double Likelihood();
  
  //void UpdateAllOutgoingMessages();


 protected:
  double message(int var);

  int N_;

  // Factors keep a persistent copy of outgoing messages in a
  // form that will help efficiently compute messages in the future.
  vector<double> *forced_zeros_;
  vector<double> *forced_ones_;

  // Internal caches used for dynamic programming
  vector<double> *lr_;
  vector<double> *rl_;
 
};

#endif
